# -*- Mode: Python; tab-width: 4 -*-

from kqsyscall import *
import os
import sys
from socket import *

kq = kqueue()

# create a server socket
server = socket(AF_INET, SOCK_STREAM)
server.setsockopt (
    SOL_SOCKET, SO_REUSEADDR,
    server.getsockopt (SOL_SOCKET, SO_REUSEADDR) | 1
    )
server.bind (("", 9001))
server.listen(-1) 

# Create a kevent for the listening socket
server_fd = server.fileno()

# the change-list initially contains the server socket
changes = [kevent (server_fd)]

clients = {}

while 1:
    print '-------------------------------------------'
    #sys.stderr.write ('kevent-->')
    todo = kq.kevent (changes, 250, 30000)
    # clear the changes list each time through
    changes = []
    #sys.stderr.write (' %s' % repr(todo))
    for event in todo:
        ident = event.ident
        if ident == server_fd:
            client, addr = server.accept()
            client_fd = client.fileno()
            sys.stderr.write ('[%d opened from %s]\n' % (client_fd, addr))
            # request events for this channel
            changes.append (kevent (client_fd))
            # keep track of all clients
            clients[client_fd] = client
        elif clients.has_key (ident):
            # read from a client
            client = clients[ident]
            data = client.recv (8192)
            if data:
                sys.stderr.write ('[%d] %s\n' % (ident, repr(data)))
            else:
                client.close()
                # forget this client
                del clients[ident]
                sys.stderr.write ('[%d closed]\n' % (ident))
                # tell our kqueue to forget this fd
                changes.append (kevent (ident, (EVFILT_READ|EVFILT_WRITE), EV_DELETE))
        else:
            sys.stderr.write ('unknown ident: %d\n' % (ident))
